install 55 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826827828829830831832833834835836837838839840841842843844845846847848849850851852853854855856857858859860861862863864865866867868869870871872873874875876877878879880881882883884885886887888889890891892893894895896897898899900901902903904905906907908909910911912913914915916917918919920921922923924925926927928929930931932933934935936937938939940941942943944945946947948949950951952953954955956957958959960961962963964965966967968969970971972973974975976977978979980981982983984985986987988989990991992993994995996997998999100010011002100310041005100610071008100910101011101210131014101510161017101810191020102110221023102410251026102710281029103010311032103310341035103610371038103910401041104210431044104510461047104810491050105110521053105410551056105710581059106010611062106310641065106610671068106910701071107210731074107510761077107810791080108110821083108410851086108710881089109010911092109310941095109610971098109911001101110211031104110511061107110811091110111111121113111411151116111711181119112011211122112311241125112611271128112911301131113211331134113511361137113811391140114111421143114411451146114711481149115011511152115311541155115611571158115911601161116211631164116511661167116811691170117111721173117411751176117711781179118011811182118311841185118611871188118911901191119211931194119511961197119811991200120112021203120412051206120712081209121012111212121312141215121612171218121912201221122212231224122512261227122812291230123112321233123412351236123712381239124012411242124312441245124612471248124912501251125212531254125512561257125812591260126112621263126412651266126712681269127012711272127312741275127612771278127912801281128212831284128512861287128812891290129112921293129412951296129712981299130013011302130313041305130613071308130913101311131213131314131513161317131813191320132113221323132413251326132713281329133013311332133313341335133613371338133913401341134213431344134513461347134813491350135113521353135413551356135713581359136013611362136313641365136613671368136913701371137213731374137513761377137813791380138113821383138413851386138713881389139013911392139313941395139613971398139914001401140214031404140514061407140814091410141114121413141414151416141714181419142014211422142314241425142614271428142914301431143214331434143514361437143814391440144114421443144414451446144714481449145014511452145314541455145614571458145914601461146214631464146514661467146814691470147114721473147414751476147714781479148014811482148314841485148614871488148914901491149214931494149514961497149814991500150115021503150415051506150715081509151015111512151315141515151615171518151915201521152215231524152515261527152815291530153115321533153415351536153715381539154015411542154315441545154615471548154915501551155215531554155515561557155815591560156115621563156415651566156715681569157015711572157315741575157615771578157915801581158215831584158515861587158815891590159115921593159415951596159715981599160016011602160316041605160616071608160916101611161216131614161516161617161816191620162116221623162416251626162716281629163016311632163316341635163616371638163916401641164216431644164516461647164816491650165116521653165416551656165716581659166016611662166316641665166616671668166916701671167216731674167516761677167816791680168116821683168416851686168716881689169016911692169316941695169616971698169917001701170217031704170517061707
  1. #!/bin/bash
  2. #################################################################
  3. # auto-mediawiki #
  4. # Instala un servidor LAMP (Linux+Apache+MySQL+PHP) e instala #
  5. # MediaWiki y lo configura. #
  6. # #
  7. # Guzman Castanedo Villalba (guzman@castanedo.es) Junio 2018 #
  8. # GPLv3 (https://www.gnu.org/licenses/gpl.html) #
  9. #################################################################
  10. comprobarError() {
  11. # Permite comprobar si se ha producido un error y de serlo devuelve un código de error
  12. # comprobarError exitNum codeNum extraInfo
  13. # 1xx: Servidor Web
  14. # 2xx: Base de Datos
  15. # 3xx: PHP
  16. # 4xx: SSL/TLS
  17. # 5xx: MediaWiki
  18. # 6xx: Moodle
  19. # 7xx: Backup automático
  20. # 8xx: Dependencias
  21. # 9xx: Servicios & Firewall
  22. type="ERROR"
  23. exitNum=$1
  24. shift
  25. codeNum=$1
  26. shift
  27. extraInfo=$@
  28. case $codeNum in
  29. 1)
  30. error="$type $codeNum:\tInstalación interrumpida por el usuario.\n"
  31. ;;
  32. 2)
  33. error="$type $codeNum:\tError interno (selección express).\n"
  34. ;;
  35. 3)
  36. error="$type $codeNum:\tError interno (selección avanzada).\n"
  37. ;;
  38. 4)
  39. error="\n$type $codeNum:\tEl archivo '"$(realpath $extraInfo)"' no existe.\n"
  40. ;;
  41. 5)
  42. error="\n$type $codeNum:\tEl directorio '"$(realpath $extraInfo)"' no existe.\n"
  43. ;;
  44. 6)
  45. error="$type $codeNum:\tError interno (selección SSL/TLS).\n"
  46. ;;
  47. 100)
  48. error="$type $codeNum:\tError interno (selección del servidor web).\n"
  49. ;;
  50. 101)
  51. error="\n$type $codeNum:\tError al instalar Apache2.\nDetalles:\n$extraInfo\n"
  52. ;;
  53. 102)
  54. error="\n$type $codeNum:\tError al instalar Nginx.\nDetalles:\n$extraInfo\n"
  55. ;;
  56. 103)
  57. error="\n$type $codeNum:\tError al nstalar repositorio 'epel-release'.\nDetalles:\n$extraInfo\n"
  58. ;;
  59. 104)
  60. error="\n$type $codeNum:\tError interno (instalación Apache2).\n"
  61. ;;
  62. 105)
  63. error="\n$type $codeNum:\tError interno (instalación Nginx).\n"
  64. ;;
  65. 106)
  66. type="WARNING"
  67. error="\n$type $codeNum:\tImposible instalar 'info.php'.\n"
  68. ;;
  69. 107)
  70. error="\n$type $codeNum:\tError al configurar Nginx.\n"
  71. ;;
  72. 108)
  73. error="\n$type $codeNum:\tError al configurar Apache2.\n"
  74. ;;
  75. 200)
  76. error="$type $codeNum:\tError interno (selección de base de datos).\n"
  77. ;;
  78. 201)
  79. error="\n$type $codeNum:\tError al instalar MySQL.\nDetalles:\n$extraInfo\n"
  80. ;;
  81. 202)
  82. error="\n$type $codeNum:\tError al instalar MariaDB.\nDetalles:\n$extraInfo\n"
  83. ;;
  84. 203)
  85. error="\n$type $codeNum:\tError interno (instalación MySQL).\n"
  86. ;;
  87. 204)
  88. error="\n$type $codeNum:\tError interno (instalación MariaDB).\n"
  89. ;;
  90. 205)
  91. error="\n$type $codeNum:\t$DIST no incluye MySQL en sus repositorios.\n"
  92. ;;
  93. 206)
  94. type="WARNING"
  95. error="\n$type $codeNum:\tUsuario 'root' ya dispone de contraseña."
  96. ;;
  97. 207)
  98. error="\n$type $codeNum:\tImposible cambiar la contraseña de 'root'."
  99. ;;
  100. 208)
  101. error="\n$type $codeNum:\tImposible desactivar acceso 'root' desde el exterior."
  102. ;;
  103. 209)
  104. error="\n$type $codeNum:\tImposible eliminar usuarios anónimos."
  105. ;;
  106. 210)
  107. type="WARNING"
  108. error="\n$type $codeNum:\tImposible eliminar bases de datos de pruebas."
  109. ;;
  110. 211)
  111. type="WARNING"
  112. error="\n$type $codeNum:\tImposible eliminar los permisos de las bases de datos de pruebas."
  113. ;;
  114. 212)
  115. error="\n$type $codeNum:\tImposible recargar base de datos."
  116. ;;
  117. 213)
  118. error="\n$type $codeNum:\tImposible configurar SQL.\n"
  119. ;;
  120. 214)
  121. type="WARNING"
  122. error="\n$type $codeNum:\tSQL ya está configurado."
  123. ;;
  124. 300)
  125. error="\n$type $codeNum:\tError interno (instalación PHP-7.2).\n"
  126. ;;
  127. 301)
  128. error="\n$type $codeNum:\tError interno (Web Server no seleccionado).\n"
  129. ;;
  130. 302)
  131. error="\n$type $codeNum:\tError al instalar PHP-7.2.\nDetalles:\n$extraInfo\n"
  132. ;;
  133. 303)
  134. error="\n$type $codeNum:\tError al instalar Repositorio Remi.\nDetalles:\n$extraInfo\n"
  135. ;;
  136. 304)
  137. error="\n$type $codeNum:\tSistema Operativo no compatible con PHP-7.2 ($OS $DIST $REV).\n"
  138. ;;
  139. 305)
  140. error="\n$type $codeNum:\tImposible configurar PHP-7.2.\n"
  141. ;;
  142. 501)
  143. error="\n$type $codeNum:\tImposible descargar MediaWiki-1.31.0.\n"
  144. ;;
  145. 502)
  146. error="\n$type $codeNum:\tImposible configurar MediaWiki-1.31.0.\n"
  147. ;;
  148. 503)
  149. type="WARNING"
  150. error="\n$type $codeNum:\tYa existe una copia configurada de MediaWiki en el dominio: '$extraInfo'."
  151. ;;
  152. 601)
  153. error="\n$type $codeNum:\tImposible descargar Moodle-3.5.1.\n"
  154. ;;
  155. 602)
  156. error="\n$type $codeNum:\tImposible configurar Moodle-3.5.1.\n"
  157. ;;
  158. 603)
  159. type="WARNING"
  160. error="\n$type $codeNum:\tYa existe una copia configurada de Moodle en el dominio: '$extraInfo'."
  161. ;;
  162. 604)
  163. error="\n$type $codeNum:\tImposible configurar SELinux.\n"
  164. ;;
  165. 605)
  166. error="\n$type $codeNum:\tImposible instalar 'policycoreutils-python'.Detalles:\n$extraInfo\n"
  167. ;;
  168. 800)
  169. error="$type $codeNum:\tEs necesario ser root ('sudo $0').\n"
  170. ;;
  171. 801)
  172. error="$type $codeNum:\t'whiptail' no instalado.\n"
  173. ;;
  174. 802)
  175. error="$type $codeNum:\t'hostnamectl' no instalado.\n"
  176. ;;
  177. 803)
  178. error="$type $codeNum:\t'apt-get' no instalado.\n"
  179. ;;
  180. 804)
  181. error="$type $codeNum:\t'yum' no instalado.\n"
  182. ;;
  183. 805)
  184. error="\n$type $codeNum:\tImposible actualizar repositorio\nDetalles:\n$extraInfo.\n"
  185. ;;
  186. 806)
  187. error="$type $codeNum:\t'ufw' no instalado.\n"
  188. ;;
  189. 807)
  190. error="$type $codeNum:\t'firewall-cmd' no instalado.\n"
  191. ;;
  192. 808)
  193. error="$type $codeNum:\t'tput' no instalado.\nDetalles:\n$extraInfo\n"
  194. ;;
  195. 809)
  196. error="$type $codeNum:\t'sed' no instalado.\nDetalles:\n$extraInfo\n"
  197. ;;
  198. 810)
  199. error="$type $codeNum:\t'curl' no instalado.\nDetalles:\n$extraInfo\n"
  200. ;;
  201. 811)
  202. error="$type $codeNum:\t'tar' no instalado.\nDetalles:\n$extraInfo\n"
  203. ;;
  204. 812)
  205. error="$type $codeNum:\t'gzip' no instalado.\nDetalles:\n$extraInfo\n"
  206. ;;
  207. 813)
  208. error="$type $codeNum:\t'bzip2' no instalado.\nDetalles:\n$extraInfo\n"
  209. ;;
  210. 814)
  211. error="$type $codeNum:\t'xz' no instalado.\nDetalles:\n$extraInfo\n"
  212. ;;
  213. 815)
  214. error="$type $codeNum:\t'openssl' no instalado.\nDetalles:\n$extraInfo\n"
  215. ;;
  216. 816)
  217. error="$type $codeNum:\t'find' no instalado.\n"
  218. ;;
  219. 900)
  220. error="$type $codeNum:\tError interno (habilitar servicio).\n"
  221. ;;
  222. 901)
  223. error="$type $codeNum:\tImposible encender servicio '$extraInfo'.\n"
  224. ;;
  225. 902)
  226. error="$type $codeNum:\tImposible habilitar servicio '$extraInfo' durante el arranque.\n"
  227. ;;
  228. 903)
  229. error="$type $codeNum:\tError interno (deshabilitar servicio).\n"
  230. ;;
  231. 904)
  232. error="$type $codeNum:\tImposible parar servicio '$extraInfo'.\n"
  233. ;;
  234. 905)
  235. error="$type $codeNum:\tImposible deshabilitar servicio '$extraInfo' durante el arranque.\n"
  236. ;;
  237. 906)
  238. type="WARNING"
  239. error="\n$type $codeNum:\tImposible añadir regla al cortafuegos ('$extraInfo').\n"
  240. ;;
  241. 907)
  242. type="WARNING"
  243. error="\n$type $codeNum:\tImposible encender cortafuegos.\n"
  244. ;;
  245. 908)
  246. error="\n$type $codeNum:\tError interno (instalar Virtual Host).\n"
  247. ;;
  248. 909)
  249. error="\n$type $codeNum:\tVirtual Host '$extraInfo' no existe.\n"
  250. ;;
  251. 910)
  252. error="\n$type $codeNum:\tImposible copiar Virtual Host '$extraInfo'.\n"
  253. ;;
  254. 911)
  255. error="\n$type $codeNum:\tImposible activar Virtual Host '$extraInfo'.\n"
  256. ;;
  257. 912)
  258. error="\n$type $codeNum:\tError interno (recargar servicio).\n"
  259. ;;
  260. 913)
  261. error="\n$type $codeNum:\tImposible recargar servicio '$extraInfo'.\n"
  262. ;;
  263. *)
  264. error="ERROR 13:\tError interno (comprobación de errores)\n"
  265. exitNum=1
  266. codeNum=13
  267. ;;
  268. esac
  269. if [ $exitNum -ne 0 ];then
  270. echo -en "$error" | tee -a $logFile
  271. if [ $type = "ERROR" ];then
  272. exit $codeNum
  273. fi
  274. fi
  275. unset error exitNum codeNum type
  276. }
  277. OSInfo() {
  278. # Detecta el OS en el que se está ejecutando el programa, así como su versión
  279. echo -en "Detectando SO..." >> $logFile
  280. OS=$(uname -s)
  281. if [ $OS = "Linux" ]; then
  282. OS="GNU/Linux"
  283. if [ -f /etc/os-release ]; then
  284. DIST=$(grep ^NAME= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  285. REV=$(grep ^VERSION= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  286. ID_LIKE=$(grep ^ID_LIKE= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  287. VERSION=$(grep ^VERSION_ID= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  288. for i in $ID_LIKE; do
  289. #echo -en "$i\n"
  290. case $i in
  291. debian|ubuntu)
  292. debianOS=true
  293. break
  294. ;;
  295. rhel|fedora)
  296. rhelOS=true
  297. break
  298. ;;
  299. *)
  300. debianOS=false
  301. rhelOS=false
  302. ;;
  303. esac
  304. done
  305. elif [ -f /etc/debian-version ]; then
  306. # Familia Debian (Debian, Ubuntu, Linux Mint, ...)
  307. DIST="Debian"
  308. REV=""
  309. ID_LIKE="debian"
  310. VERSION=""
  311. debianOS=true
  312. elif [ -f /etc/redhat-release ]; then
  313. # Familia Red-Hat (RHEL, Fedora, CentOS, ...)
  314. DIST="Red-Hat"
  315. REV=""
  316. ID_LIKE="rhel"
  317. VERSION=""
  318. rhelOS=true
  319. else
  320. # Other Linux (No Soportado)
  321. DIST=""
  322. REV=""
  323. ID_LIKE=""
  324. VERSION=""
  325. fi
  326. else
  327. # UNIX, OS X, ... (No Soportado)
  328. DIST=$OS
  329. REV=""
  330. ID_LIKE=""
  331. VERSION=""
  332. fi
  333. echo -en " $OS $DIST $REV\n" >> $logFile
  334. HDInfo=$(df -h | head -1)"\n"$(df -h | grep ^/dev/sd)"\n"$(df -h | grep ^/dev/mapper)
  335. echo -en "$HDInfo\n" >> $logFile
  336. }
  337. comprobarRoot() {
  338. # Comprueba si se está ejecutando con privilegios de root
  339. comprobarError $(id -u) 800
  340. }
  341. comprobarDependencias() {
  342. # Comprueba si están instalados todos los programas necesarios.
  343. # En la mayoría de los casos, trata de instalarlos.
  344. # Comprobamos whiptail
  345. which whiptail > /dev/null 2>&1
  346. comprobarError $? 801
  347. # Comprobamos hostnamectl
  348. which hostnamectl > /dev/null 2>&1
  349. comprobarError $? 802
  350. which find > /dev/null 2>&1
  351. comprobarError $? 816
  352. if [ $debianOS = true ];then
  353. # Comprobamos apt-get
  354. which apt-get > /dev/null 2>&1
  355. comprobarError $? 803
  356. # Actualizamos base de datos del repositorio
  357. echo -en "Actualizando repositorio APT..." | tee -a $logFile
  358. result=$(apt-get -q -y update 2>&1)
  359. comprobarError $? 805 $result
  360. echo -en " OK.\n" | tee -a $logFile
  361. # Comprobamos Firewall (ufw)
  362. which ufw > /dev/null 2>&1
  363. comprobarError $? 806
  364. # Comprobamos tput
  365. which tput > /dev/null 2>&1
  366. if [ $? -ne 0 ];then
  367. result=$(apt-get -q -y ncurses-bin 2>&1)
  368. comprobarError $? 808 $result
  369. fi
  370. # Comprobar sed
  371. which sed > /dev/null 2>&1
  372. if [ $? -ne 0 ];then
  373. result=$(apt-get -q -y sed 2>&1)
  374. comprobarError $? 809 $result
  375. fi
  376. # Comprobar curl
  377. which curl > /dev/null 2>&1
  378. if [ $? -ne 0 ];then
  379. result=$(apt-get -q -y curl 2>&1)
  380. comprobarError $? 810 $result
  381. fi
  382. # Comprobamos tar, gzip, bzip2 y xz
  383. which tar > /dev/null 2>&1
  384. if [ $? -ne 0 ];then
  385. result=$(apt-get -q -y install tar 2>&1)
  386. comprobarError $? 811 $result
  387. fi
  388. which gzip > /dev/null 2>&1
  389. if [ $? -ne 0 ];then
  390. result=$(apt-get -q -y install gzip 2>&1)
  391. comprobarError $? 812 $result
  392. fi
  393. which bzip2 > /dev/null 2>&1
  394. if [ $? -ne 0 ];then
  395. result=$(apt-get -q -y install bzip2 2>&1)
  396. comprobarError $? 813 $result
  397. fi
  398. which xz > /dev/null 2>&1
  399. if [ $? -ne 0 ];then
  400. result=$(apt-get -q -y install xz-utils 2>&1)
  401. comprobarError $? 814 $result
  402. fi
  403. which openssl > /dev/null 2>&1
  404. if [ $? -ne 0 ];then
  405. result=$(apt-get -q -y install openssl 2>&1)
  406. comprobarError $? 815 $result
  407. fi
  408. fi
  409. if [ $rhelOS = true ]; then
  410. # Comprobamos yum
  411. which yum > /dev/null 2>&1
  412. comprobarError $? 804
  413. # Actualizamos base de datos del repositorio
  414. echo -en "Actualizando repositorio YUM..." | tee -a $logFile
  415. result=$(yum -y makecache 2>&1)
  416. comprobarError $? 805 $result
  417. echo -en " OK.\n" | tee -a $logFile
  418. # Comprobamos Firewall (firewall-cmd)
  419. which firewall-cmd > /dev/null 2>&1
  420. comprobarError $? 807
  421. # Comprobamos tput
  422. which tput > /dev/null 2>&1
  423. if [ $? -ne 0 ];then
  424. result=$(yum -y ncurses 2>&1)
  425. comprobarError $? 808 $result
  426. fi
  427. # Comprobar sed
  428. which sed > /dev/null 2>&1
  429. if [ $? -ne 0 ];then
  430. result=$(yum -y sed 2>&1)
  431. comprobarError $? 809 $result
  432. fi
  433. # Comprobar curl
  434. which curl > /dev/null 2>&1
  435. if [ $? -ne 0 ];then
  436. result=$(yum -y curl 2>&1)
  437. comprobarError $? 810 $result
  438. fi
  439. # Comprobamos tar, gzip, bzip2 y xz
  440. which tar > /dev/null 2>&1
  441. if [ $? -ne 0 ];then
  442. result=$(yum -y install tar 2>&1)
  443. comprobarError $? 811 $result
  444. fi
  445. which gzip > /dev/null 2>&1
  446. if [ $? -ne 0 ];then
  447. result=$(yum -y install gzip 2>&1)
  448. comprobarError $? 812 $result
  449. fi
  450. which bzip2 > /dev/null 2>&1
  451. if [ $? -ne 0 ];then
  452. result=$(yum -y install bzip2 2>&1)
  453. comprobarError $? 813 $result
  454. fi
  455. which xz > /dev/null 2>&1
  456. if [ $? -ne 0 ];then
  457. result=$(yum -y install xz 2>&1)
  458. comprobarError $? 814 $result
  459. fi
  460. which openssl > /dev/null 2>&1
  461. if [ $? -ne 0 ];then
  462. result=$(yum -y install openssl 2>&1)
  463. comprobarError $? 815 $result
  464. fi
  465. fi
  466. }
  467. inicializarVariables() {
  468. # Inicializa las variables que necesitan de un estado previo
  469. debianOS=false
  470. rhelOS=false
  471. apacheOn=false
  472. nginxOn=false
  473. mySQLOn=false
  474. mariaDBOn=false
  475. phpOn=false
  476. sslOn=false
  477. letsEncryptOn=false
  478. mediaWikiOn=false
  479. moodleOn=false
  480. infoPHPOn=false
  481. backupOn=false
  482. hostname=""
  483. logFile="./."$(basename $0)".log"
  484. maxUpload="100M"
  485. webServerName=""
  486. webServerUser=""
  487. webServerGroup=""
  488. sqlServerName=""
  489. phpFPMName=""
  490. nombreMediaWiki=""
  491. dominioMediaWiki=""
  492. passwdMediaWiki=""
  493. nombreMoodle=""
  494. nombreCortoMoodle=""
  495. dominioMoodle=""
  496. passwdMoodle=""
  497. }
  498. instalacionExpress() {
  499. # Permite una instalación rápida, haciendo el menor número de preguntas
  500. apacheOn=true
  501. mariaDBOn=true
  502. phpOn=true
  503. sslOn=true
  504. letsEncryptOn=true
  505. mediaWikiOn=true
  506. moodleOn=true
  507. backupOn=true
  508. # Preguntas mínimas
  509. establecerFQDN
  510. leerSQLPasswd
  511. mostrarMediaWiki
  512. mostrarMoodle
  513. }
  514. mostrarBienvenida() {
  515. # Pantalla de bienvenida y muestra SO y estado de los discos
  516. ANCHO=$(tput cols)
  517. ALTO=$(tput lines)
  518. if [ $debianOS = false ] && [ $rhelOS = false ]; then
  519. whiptail --title "ERROR S.O. NO SOPORTADO" --msgbox "Este script automatiza la creación de una web MediaWiki SOLO para distribuciones Linux de la familia Debian (Ubuntu, Linux Mint, ...) y de la familia Red-Hat (CentOS, Fedora, ...).\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Salir"
  520. exit 1
  521. fi
  522. whiptail --title "INSTALACION MEDIAWIKI" --yesno "Este script automatiza completamente la instalación de una WIKI y un CAMPUS VIRTUAL.\nPara ello instala un servidor LAMP, el software MediaWiki y configura todo lo necesario.\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --yes-button "Continuar" --no-button "Salir"
  523. comprobarError $? 1
  524. }
  525. mostrarExpress() {
  526. # Pantalla de elección entre instalación express o avanzada
  527. express=$(whiptail --title "INSTALACION EXPRESS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nLa instalación express instala Apache2, MariaDB, PHP-7, Let's Encrypt, MediaWiki, Moodle y backups automático.\nSeleccione el tipo de instalación que desee:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  528. "Express" "Instalación rápida" ON \
  529. "Avanzada" "Permite escoger todas las opciones disponibles" OFF \
  530. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  531. comprobarError $? 1
  532. case $express in
  533. Express)
  534. instalacionExpress
  535. # DECIDIR QUÉ OPCIONES SON LAS MÍNIMAS
  536. ;;
  537. Avanzada)
  538. mostrarAvanzada
  539. ;;
  540. *)
  541. comprobarError 1 2
  542. ;;
  543. esac
  544. unset express
  545. }
  546. mostrarAvanzada() {
  547. # Pantalla que permite instalar un servidor LAMP o LEMP
  548. webServer=$(whiptail --title "INSTALACION AVANZADA" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el tipo de Servidor Web que quieres instalar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  549. "LAMP" "GNU/Linux + Apache + MySQL/MariaDB + PHP-7" ON \
  550. "LEMP" "GNU/Linux + Nginx + MySQL/MariaDB + PHP-7" OFF \
  551. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  552. comprobarError $? 1
  553. for i in $webServer; do
  554. case $i in
  555. LAMP)
  556. apacheOn=true
  557. ;;
  558. LEMP)
  559. nginxOn=true
  560. ;;
  561. *)
  562. comprobarError 1 100
  563. ;;
  564. esac
  565. done
  566. # Opciones comunes
  567. establecerFQDN
  568. mostrarDatabase
  569. phpOn=true
  570. establecerMaxUpload
  571. mostrarComponentes
  572. mostrarConfirmacion
  573. unset webServer
  574. }
  575. mostrarComponentes() {
  576. # Pantalla de elección de componentes (SSL/TLS, MediaWiki, Moodle, InfoPHP y Backup)
  577. componentes=$(whiptail --title "INSTALACION AVANZADA" --checklist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge los componentes que quieres instalar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 5 \
  578. "SSL/TLS" "Instalar certificados para activar HTTPS" ON \
  579. "MediaWiki" "Instalar wiki con MediaWiki" ON \
  580. "Moodle" "Instalar campus virtual con Moodle" ON \
  581. "InfoPHP" "Instalar info.php (sólo para pruebas)" OFF \
  582. "Backup" "Programar backups automáticos" ON \
  583. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  584. comprobarError $? 1
  585. # Mejora: autodetección de componentes ya instalados
  586. for i in $componentes; do
  587. case $i in
  588. \"SSL/TLS\")
  589. # 2 Opciones: Let's Encrypt o Autofirmado
  590. mostrarSSL
  591. ;;
  592. \"MediaWiki\")
  593. mediaWikiOn=true
  594. mostrarMediaWiki
  595. ;;
  596. \"Moodle\")
  597. moodleOn=true
  598. mostrarMoodle
  599. ;;
  600. \"InfoPHP\")
  601. infoPHPOn=true
  602. ;;
  603. \"Backup\")
  604. BackupOn=true
  605. ;;
  606. *)
  607. comprobarError 1 3
  608. ;;
  609. esac
  610. done
  611. unset componentes
  612. }
  613. mostrarSSL() {
  614. # Pantalla que permite seleccionar el tipo de certificados
  615. ssl=$(whiptail --title "INSTALACION SSL/TLS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el tipo de Certificado SSL/TLS que quieres instalar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  616. "LetsEncrypt" "Compatible con todos los navegadores" ON \
  617. "Auto-Firmado" "Certificados auto-firmados (sólo para pruebas)" OFF \
  618. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  619. comprobarError $? 1
  620. for i in $ssl; do
  621. case $i in
  622. LetsEncrypt)
  623. sslOn=true
  624. letsEcnryptOn=true
  625. ;;
  626. Auto-Firmados)
  627. sslOn=true
  628. ;;
  629. *)
  630. comprobarError 1 6
  631. ;;
  632. esac
  633. done
  634. unset ssl
  635. }
  636. mostrarMediaWiki(){
  637. # Pantalla que pregunta sobre las opciones necesarias para configurar MediaWiki
  638. # Introducir nombre wiki
  639. while [ -z "$nombreMediaWiki" ]; do
  640. nombreMediaWiki=$(whiptail --title "CONFIGURACION MEDIAWIKI" --inputbox "Introduzca el nombre de la Wiki:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  641. comprobarError $? 1
  642. done
  643. # Introducir dominio
  644. while [ -z "$dominioMediaWiki" ]; do
  645. dominioMediaWiki=$(whiptail --title "CONFIGURACION MEDIAWIKI" --inputbox "Introduzca el dominio/subdominio de la Wiki.\nTenga en cuenta que debes apuntar este dominio a la dirección IP de esta máquina mediante un registro DNS de tipo CNAME.\nSi quiere introducir varios dominios sepárelos con espacios. El primero será el principal.\nPor ejemplo: 'www.$hostname $hostname wiki.$hostname'" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) wiki.$hostname --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  646. comprobarError $? 1
  647. done
  648. cont=1
  649. serverName=""
  650. aliasMediaWiki=""
  651. for dominio in $dominioMediaWiki;do
  652. if [ $cont -eq 1 ];then
  653. # Dominio Principal (ServerName)
  654. serverName=$dominio
  655. else
  656. # Dominios Secundarios (ServerAlias)
  657. aliasMediaWiki=$aliasMediaWiki" "$dominio
  658. fi
  659. cont=$((cont + 1))
  660. done
  661. dominioMediaWiki=$serverName
  662. # Introducir contraseña
  663. control=false
  664. error=""
  665. while [ $control = false ]; do
  666. passwdMediaWiki=$(whiptail --title "CONFIGURACION MEDIAWIKI" --passwordbox "$error""Introduzca la contraseña para el usuario administrador 'admin':" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  667. comprobarError $? 1
  668. passwdMediaWiki2=$(whiptail --title "CONFIGURACION MEDIAWIKI" --passwordbox "Confirme la contraseña:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  669. comprobarError $? 1
  670. if [ -z "$passwdMediaWiki" ] || [ -z "$passwdMediaWiki2" ]; then
  671. error="ERROR: LA CONTRASEÑA NO PUEDE ESTAR VACIA.\n"
  672. elif [ $passwdMediaWiki != $passwdMediaWiki2 ];then
  673. error="ERROR: LAS CONTRASEÑAS NO COINCIDEN.\n"
  674. else
  675. control=true
  676. fi
  677. done
  678. unset control error passwdMediaWiki2 dominio cont serverName
  679. }
  680. mostrarMoodle() {
  681. # Pantalla que pregunta sobre las opciones necesarias para configurar Moodle
  682. # Introducir Nombre Moodle
  683. while [ -z "$nombreMoodle" ]; do
  684. nombreMoodle=$(whiptail --title "CONFIGURACION MOODLE" --inputbox "Introduzca el NOMBRE COMPLETO del campus virtual.\nPor ejemplo: 'Campus Virtual Ejemplo'." $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  685. comprobarError $? 1
  686. done
  687. # Introducir Nombre Corto Moodle
  688. while [ -z "$nombreCortoMoodle" ]; do
  689. nombreCortoMoodle=$(whiptail --title "CONFIGURACION MOODLE" --inputbox "Introduzca el NOMBRE CORTO del campus virtual.\nPor ejemplo: 'Ejemplo'." $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  690. comprobarError $? 1
  691. done
  692. # Introducir dominio
  693. while [ -z "$dominioMoodle" ]; do
  694. dominioMoodle=$(whiptail --title "CONFIGURACION MOODLE" --inputbox "Introduzca el dominio/subdominio del campus virtual.\nMoodle SÓLO permite un ÚNICO DOMINIO." $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) moodle.$hostname --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  695. comprobarError $? 1
  696. done
  697. cont=1
  698. serverName=""
  699. aliasMoodle=""
  700. for dominio in $dominioMoodle;do
  701. if [ $cont -eq 1 ];then
  702. # Dominio Principal (ServerName)
  703. serverName=$dominio
  704. else
  705. # Dominios Secundarios (ServerAlias)
  706. aliasMeoodle=$aliasMoodle" "$dominio
  707. fi
  708. cont=$((cont + 1))
  709. done
  710. dominioMoodle=$serverName
  711. # Introducir contraseña
  712. control=false
  713. error=""
  714. while [ $control = false ]; do
  715. passwdMoodle=$(whiptail --title "CONFIGURACION MOODLE" --passwordbox "$error""Introduzca la contraseña para el usuario administrador 'admin':" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  716. comprobarError $? 1
  717. passwdMoodle2=$(whiptail --title "CONFIGURACION MOODLE" --passwordbox "Confirme la contraseña:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  718. comprobarError $? 1
  719. if [ -z "$passwdMoodle" ] || [ -z "$passwdMoodle2" ]; then
  720. error="ERROR: LA CONTRASEÑA NO PUEDE ESTAR VACIA.\n"
  721. elif [ $passwdMoodle != $passwdMoodle2 ];then
  722. error="ERROR: LAS CONTRASEÑAS NO COINCIDEN.\n"
  723. else
  724. control=true
  725. fi
  726. done
  727. unset control error passwdMoodle2 dominio cont serverName aliasMoodle
  728. }
  729. mostrarConfirmacion() {
  730. # Pantalla que presenta una confirmación antes de realizar la instalación
  731. whiptail --title "INSTALACION" --yesno "ESTA TODO LISTO PARA LA INSTALACION.\n¿DESEA CONTINUAR?" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --yes-button "Instalar" --no-button "Salir"
  732. comprobarError $? 1
  733. }
  734. establecerFQDN() {
  735. # Configura el FQDN (dominio principal del servidor)
  736. while [ -z "$hostname" ]; do
  737. hostname=$(whiptail --title "FQDN" --inputbox "El nombre de dominio principal (FQDN) de este servidor es:\n"$(hostname)"\n\n¿Quieres cambiarlo por otro?" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Cambiar" --cancel-button "No Cambiar" 3>&1 1>&2 2>&3)
  738. if [ $? -eq 0 ] && [ ! -z "$hostname" ]; then
  739. hostnamectl set-hostname $hostname
  740. else
  741. hostname=$(hostname)
  742. fi
  743. done
  744. echo -en "Hostname: $hostname\n" >> $logFile
  745. }
  746. instalarApache() {
  747. # Instala Apache2
  748. if [ $debianOS = true ];then
  749. webServerName="apache2"
  750. result=$(apt-get -q -y install apache2 2>&1)
  751. comprobarError $? 101 $result
  752. elif [ $rhelOS = true ]; then
  753. webServerName="httpd"
  754. result=$(yum -y install httpd 2>&1)
  755. comprobarError $? 101 $result
  756. else
  757. comprobarError 1 104
  758. fi
  759. deshabilitarServicio $webServerName
  760. }
  761. configurarApache() {
  762. # Configura Apache2
  763. if [ $debianOS = true ];then
  764. apacheConfFile="./etc/apache2/apache2.conf"
  765. if [ ! -f $apacheConfFile ];then
  766. comprobarError 1 4 $apacheConfFile
  767. fi
  768. cp -f $apacheConfFile /etc/$webServerName/apache2.conf 2>/dev/null
  769. comprobarError $? 108
  770. webServerUser=$(grep ^User /etc/$webServerName/apache2.conf | cut -d ' ' -f 2)
  771. webServerGroup=$(grep ^Group /etc/$webServerName/apache2.conf | cut -d ' ' -f 2)
  772. if [ ! -L /etc/$webServerName/logs ];then
  773. ln -s /var/log/apache2 /etc/$webServerName/logs 2>/dev/null
  774. comprobarError $? 108
  775. fi
  776. # Activamos mod_rewrite (no viene activado por defecto)
  777. a2enmod rewrite >/dev/null 2>&1
  778. comprobarError $? 108
  779. elif [ $rhelOS = true ];then
  780. apacheConfFile="./etc/apache2/conf/httpd.conf"
  781. welcomeConfFile="/etc/apache2/conf.d/welcome.conf"
  782. if [ ! -f $apacheConfFile ];then
  783. comprobarError 1 4 $apacheConfFile
  784. fi
  785. cp -f $apacheConfFile /etc/$webServerName/conf/httpd.conf 2>/dev/null
  786. comprobarError $? 108
  787. if [ -f $welcomeConfFile ];then
  788. sed -i -e 's/^/#/' $welcomeConfFile
  789. comprobarError $? 108
  790. fi
  791. webServerUser=$(grep ^User /etc/$webServerName/conf/httpd.conf | cut -d ' ' -f 2)
  792. webServerGroup=$(grep ^Group /etc/$webServerName/conf/httpd.conf | cut -d ' ' -f 2)
  793. unset apacheConfFile welcomeConfFile
  794. fi
  795. if [ ! -d "/etc/$webServerName/sites-available" ];then
  796. mkdir "/etc/$webServerName/sites-available" 2>/dev/null
  797. comprobarError $? 5 "/etc/$webServerName/sites-available"
  798. fi
  799. if [ ! -d "/etc/$webServerName/sites-enabled" ]; then
  800. mkdir "/etc/$webServerName/sites-enabled" 2>/dev/null
  801. comprobarError $? 5 "/etc/$webServerName/sites-enabled"
  802. else
  803. # Eliminar Virtual Host por defecto
  804. if [ -f /etc/$webServerName/sites-enabled/000-default.conf ];then
  805. rm -f /etc/$webServerName/sites-enabled/000-default.conf 2>/dev/null
  806. fi
  807. fi
  808. }
  809. instalarNginx() {
  810. # Instala Nginx
  811. webServerName="nginx"
  812. if [ $debianOS = true ];then
  813. result=$(apt-get -q -y install nginx 2>&1)
  814. comprobarError $? 102 $result
  815. elif [ $rhelOS = true ]; then
  816. # Hay que instalar primero otro repositorio
  817. result=$(yum -y install epel-release)
  818. comprobarError $? 103 $result
  819. result=$(yum -y install nginx 2>&1)
  820. comprobarError $? 102 $result
  821. else
  822. comprobarError 1 105
  823. fi
  824. deshabilitarServicio $webServerName
  825. }
  826. configurarNginx() {
  827. # Configura Nginx
  828. rm -Rf "/etc/$webServerName/!(sites-available|sites-enabled)" 2>/dev/null
  829. comprobarError $? 107
  830. nginxConfFile="./etc/$webServerName"
  831. if [ -d "$nginxConfFile" ];then
  832. cp -Rf $nginxConfFile/* /etc/$webServerName/ 2>/dev/null
  833. comprobarError $? 107
  834. else
  835. comprobarError 1 5 "$nginxConfFile"
  836. fi
  837. if [ ! -d "/etc/$webServerName/sites-available" ];then
  838. mkdir "/etc/$webServerName/sites-available" 2>/dev/null
  839. comprobarError $? 5 "/etc/$webServerName/sites-available"
  840. fi
  841. if [ ! -d "/etc/$webServerName/sites-enabled" ]; then
  842. mkdir "/etc/$webServerName/sites-enabled" 2>/dev/null
  843. comprobarError $? 5 "/etc/$webServerName/sites-enabled"
  844. fi
  845. # Configuramos Usuario y Grupo
  846. if [ $debianOS = true ];then
  847. webServerUser="www-data"
  848. webServerGroup=$webServerUser
  849. elif [ $rhelOS = true ];then
  850. webServerUser="nginx"
  851. webServerGroup=$webServerUser
  852. fi
  853. sed -i '/user /c\user '$webServerUser';' /etc/$webServerName/nginx.conf
  854. comprobarError $? 107
  855. unset nginxConfFile
  856. }
  857. instalarVirtualHost() {
  858. # Configuramos un Virtual Host para Apache o Nginx
  859. # Uso: instalarVirtualHost $root $virtualHost $dominio $alias
  860. if [ $# -ge 3 ];then
  861. rootVirtualHost=$(realpath $1)
  862. shift
  863. virtualHostFile=$(realpath $1)
  864. shift
  865. dominioVirtualHost=$1
  866. virtualHostName=$dominioVirtualHost".conf"
  867. shift
  868. aliasVirtualHost=$@
  869. else
  870. comprobarError 1 908
  871. fi
  872. if [ ! -f $virtualHostFile ];then
  873. comprobarError 1 909 $virtualHostName
  874. fi
  875. if [ $apacheOn = true ];then
  876. # Configuramos root, dominio y logs
  877. sed -i '/ServerName /c\\tServerName '"$dominioVirtualHost" $virtualHostFile
  878. comprobarError $? 908
  879. if [ ! -z "$aliasVirtualHost" ];then
  880. sed -i '/ServerName /a\\tServerAlias '"$aliasVirtualHost" $virtualHostFile
  881. comprobarError $? 908
  882. fi
  883. sed -i '/DocumentRoot /c\\tDocumentRoot '"$rootVirtualHost" $virtualHostFile
  884. comprobarError $? 908
  885. sed -i '/ErrorLog /c\\tErrorLog logs/'"$dominioVirtualHost"'-error.log' $virtualHostFile
  886. comprobarError $? 908
  887. sed -i '/CustomLog /c\\tCustomLog logs/'"$dominioVirtualHost"'-access.log common' $virtualHostFile
  888. comprobarError $? 908
  889. elif [ $nginxOn = true ];then
  890. # Configuramos root, dominio, logs y php-fpm.sock (NGINX)
  891. sed -i '/root /c\\troot '$rootVirtualHost';' "$virtualHostFile"
  892. comprobarError $? 908
  893. sed -i '/server_name /c\\tserver_name '"$dominioVirtualHost"' '"$aliasVirtualHost"';' $virtualHostFile
  894. comprobarError $? 908
  895. sed -i '/access_log /c\\taccess_log /var/log/nginx/'"$dominioVirtualHost"'-access.log;' $virtualHostFile
  896. comprobarError $? 908
  897. sed -i '/error_log /c\\terror_log /var/log/nginx/'"$dominioVirtualHost"'-error.log;' $virtualHostFile
  898. comprobarError $? 908
  899. socket=$(find /var/run/ -type s -name 'php*.sock')
  900. sed -i '/fastcgi_pass /c\\t\tfastcgi_pass unix:'"$socket"';' $virtualHostFile
  901. fi
  902. # Copiamos ficheros de configuración
  903. cp -f $virtualHostFile "/etc/$webServerName/sites-available/$virtualHostName" >> $logFile 2>&1
  904. comprobarError $? 910
  905. ln -s "/etc/$webServerName/sites-available/$virtualHostName" "/etc/$webServerName/sites-enabled/$virtualHostName" >> $logFile 2>&1
  906. comprobarError $? 911 $virtualHostName
  907. recargarServicio $webServerName
  908. unset rootVirtualHost dominioVirtualHost virtualHostFile virtualHostName aliasVirtualHost socket
  909. }
  910. mostrarDatabase() {
  911. # Pantalla que permite escoger entre instalar MariaDB o MySQL
  912. if [ $debianOS = true ]; then
  913. database=$(whiptail --title "BASE DE DATOS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge la base de datos que quieres usar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  914. "MariaDB" "Instalar la base de datos MariaDB (fork de MySQL)" ON \
  915. "MySQL" "Instalar la base de datos MySQL (uso no comercial)" OFF \
  916. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  917. comprobarError $? 1
  918. case $database in
  919. MariaDB)
  920. mariaDBOn=true
  921. ;;
  922. MySQL)
  923. mySQLOn=true
  924. ;;
  925. *)
  926. comprobarError 1 200
  927. ;;
  928. esac
  929. unset database
  930. elif [ $rhelOS = true ]; then
  931. whiptail --title "BASE DE DATOS" --yesno "Para su distribucion $OS $DIST $REV, sólo está disponible la base de datos MariaDB." $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --yes-button "Continuar" --no-button "Salir"
  932. comprobarError $? 1
  933. mariaDBOn=true
  934. else
  935. comprobarError 1 200
  936. fi
  937. # Otras opciones (contraseña)
  938. leerSQLPasswd
  939. }
  940. leerSQLPasswd() {
  941. # Pantalla para leer la contraseña para el usuario root de SQL
  942. control=false
  943. error=""
  944. # Leemos la contreseña (stdin) y confirmamos
  945. while [ $control = false ]; do
  946. sqlPasswd=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "$error""Introduzca la contraseña para el usuario 'root' de la base de datos:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  947. comprobarError $? 1
  948. sqlPasswd2=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "Confirme la contraseña:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  949. comprobarError $? 1
  950. #echo -en "SQL Password 1: $sqlPasswd\n"
  951. #echo -en "SQL Password 2: $sqlPasswd2\n"
  952. if [ -z "$sqlPasswd" ] || [ -z "$sqlPasswd2" ]; then
  953. error="ERROR: LA CONTRASEÑA NO PUEDE ESTAR VACIA.\n"
  954. elif [ $sqlPasswd != $sqlPasswd2 ];then
  955. error="ERROR: LAS CONTRASEÑAS NO COINCIDEN.\n"
  956. else
  957. control=true
  958. fi
  959. done
  960. #echo -en "SQL Password: $sqlPasswd\n"
  961. unset control error sqlPasswd2
  962. }
  963. establecerSQLPasswd() {
  964. # Establecemos SQL root passwd y securizamos BD (mysql_secure_installation)
  965. # Comprobamos si ya tiene una contraseña asignada
  966. mysql -e "FLUSH PRIVILEGES" >> $logFile 2>&1
  967. if [ $? -eq 0 ];then
  968. # Establecemos contraseña del usuario root (y desactivamos posibles plugins para forzar login por contraseña)
  969. mysql -e "UPDATE mysql.user SET plugin = '', Password = PASSWORD('$sqlPasswd') WHERE User = 'root'" >> $logFile 2>&1
  970. if [ $? -ne 0 ];then
  971. # Lo intentamos de otra forma (para versiones modernas de mysql)
  972. mysql -e "ALTER USER 'root'@'localhost' IDENTIFIED WITH mysql_native_password BY '$sqlPasswd'" >> $logFile 2>&1
  973. comprobarError $? 207
  974. fi
  975. # Aplicamos el cambio de contraseña
  976. mysql -e "FLUSH PRIVILEGES" >> $logFile 2>&1
  977. # Desactivamos acceso root desde el exterior (solo localhost)
  978. mysql -u root --password=$sqlPasswd -e "DELETE FROM mysql.user WHERE User='root' AND Host NOT IN ('localhost', '127.0.0.1', '::1')" >> $logFile 2>&1
  979. comprobarError $? 208
  980. # Eliminamos todos los usuarios anónimos
  981. mysql -u root --password=$sqlPasswd -e "DELETE FROM mysql.user WHERE User=''" >> $logFile 2>&1
  982. comprobarError $? 209
  983. # Eliminamos bases de datos 'test'
  984. mysql -u root --password=$sqlPasswd -e "DROP DATABASE IF EXISTS test" >> $logFile 2>&1
  985. comprobarError $? 210
  986. # Eliminamos privilegios de la base de datos 'test'
  987. mysql -u root --password=$sqlPasswd -e "DELETE FROM mysql.db WHERE Db='test' OR Db='test\\_%'" >> $logFile 2>&1
  988. comprobarError $? 211
  989. # Aplicamos los cambios
  990. mysql -u root --password=$sqlPasswd -e "FLUSH PRIVILEGES" >> $logFile 2>&1
  991. comprobarError $? 212
  992. else
  993. comprobarError 1 206
  994. fi
  995. }
  996. instalarMySQL() {
  997. # Instala MySQL (sólo para Debian)
  998. sqlServerName="mysql"
  999. if [ $debianOS = true ];then
  1000. result=$(apt-get -q -y install mysql-server mysql-client 2>&1)
  1001. comprobarError $? 201 $result
  1002. elif [ $rhelOS = true ];then
  1003. # MySQL no disponible en RHEL. 2 opciones:
  1004. # 1) Instalar un repositorio adicional
  1005. # 2) No instalar MySQL en distribuciones RHEL
  1006. comprobarError 1 205
  1007. else
  1008. comprobarError 1 203
  1009. fi
  1010. deshabilitarServicio $sqlServerName
  1011. }
  1012. instalarMariaDB() {
  1013. # Instala MariaDB
  1014. sqlServerName="mariadb"
  1015. if [ $debianOS = true ];then
  1016. result=$(apt-get -q -y install mariadb-server mariadb-client 2>&1)
  1017. comprobarError $? 202 $result
  1018. elif [ $rhelOS = true ];then
  1019. result=$(yum -y install mariadb-server mariadb 2>&1)
  1020. comprobarError $? 202 $result
  1021. else
  1022. comprobarError 1 204
  1023. fi
  1024. deshabilitarServicio $sqlServerName
  1025. }
  1026. configurarSQL() {
  1027. # Configura BarracudaFS en mysql (necesario para Moodle)
  1028. # Configura MariaDB o MySQL
  1029. if [ $mariaDBOn = true ] && [ $debianOS = true ];then
  1030. sqlConfFile="/etc/mysql/my.cnf"
  1031. elif [ $mariaDBOn = true ] && [ $rhelOS = true ];then
  1032. sqlConfFile="/etc/my.cnf"
  1033. elif [ $mySQLOn = true ] && [ $debianOS = true ];then
  1034. sqlConfFile="/etc/mysql/my.cnf"
  1035. else
  1036. comprobarError 1 213
  1037. fi
  1038. if [ ! -f $sqlConfFile ];then
  1039. comprobarError 1 213
  1040. fi
  1041. grep "# Configuration for Moodle" $sqlConfFile >/dev/null 2>&1
  1042. if [ $? -ne 0 ];then
  1043. # Establecemos UTF8 (codificación de caracteres) y Barracuda (sistema de ficheros)
  1044. echo -en "\n# Configuration for Moodle\n" >> $sqlConfFile
  1045. echo -en "[client]\n" >> $sqlConfFile
  1046. echo -en "default-character-set = utf8mb4\n\n" >> $sqlConfFile
  1047. echo -en "[mysqld]\n" >> $sqlConfFile
  1048. echo -en "innodb_file_format = Barracuda\n" >> $sqlConfFile
  1049. echo -en "innodb_file_per_table = 1\n" >> $sqlConfFile
  1050. echo -en "innodb_large_prefix\n\n" >> $sqlConfFile
  1051. echo -en "character-set-server = utf8mb4\n" >> $sqlConfFile
  1052. echo -en "collation-server = utf8mb4_unicode_ci\n" >> $sqlConfFile
  1053. echo -en "skip-character-set-client-handshake\n\n" >> $sqlConfFile
  1054. echo -en "[mysql]\n" >> $sqlConfFile
  1055. echo -en "default-character-set = utf8mb4\n" >> $sqlConfFile
  1056. else
  1057. comprobarError 1 214
  1058. fi
  1059. unset sqlConfFile
  1060. }
  1061. instalarPHP() {
  1062. # Instalamos PHP-7 y los módulos PHP que necesitan MediaWiki y Moodle
  1063. if [ $debianOS = true ];then
  1064. if [ $apacheOn = true ]; then
  1065. result=$(apt-get -q -y install php libapache2-mod-php php-mysql php-intl php-mbstring php-xml php-apcu php-gd php-curl php-zip php-soap php-xmlrpc 2>&1)
  1066. comprobarError $? 302 $result
  1067. elif [ $nginxOn = true ];then
  1068. phpFPMName="php7.2-fpm"
  1069. result=$(apt-get -q -y install php-fpm php-mysql php-intl php-mbstring php-xml php-apcu php-gd php-curl php-zip php-soap php-xmlrpc 2>&1)
  1070. comprobarError $? 302 $result
  1071. deshabilitarServicio $phpFPMName
  1072. else
  1073. comprobarError 1 301
  1074. fi
  1075. elif [ $rhelOS = true ];then
  1076. # Necesitamos un repositorio adicional para PHP-7 (EPEL-RELEASE)
  1077. result=$(yum -y install epel-release yum-utils 2>&1)
  1078. comprobarError $? 103 $result
  1079. # Necesitamos un repositorio adicional para PHP-7 (REMI-RELEASE)
  1080. if [ ! -f /etc/yum.repos.d/remi-php72.repo ];then
  1081. if [ $VERSION = "7" ];then
  1082. result=$(yum -y install http://remi.mirrors.cu.be/enterprise/remi-release-7.rpm 2>&1)
  1083. comprobarError $? 303 $result
  1084. elif [ $VERSION = "6" ];then
  1085. result=$(yum -y install http://remi.mirrors.cu.be/enterprise/remi-release-6.rpm 2>&1)
  1086. comprobarError $? 303 $result
  1087. elif [ $VERSION = "28" ];then
  1088. result=$(yum -y install http://remi.mirrors.cu.be/fedora/remi-release-28.rpm 2>&1)
  1089. comprobarError $? 303 $result
  1090. elif [ $VERSION = "27" ];then
  1091. result=$(yum -y install http://remi.mirrors.cu.be/fedora/remi-release-27.rpm 2>&1)
  1092. comprobarError $? 303 $result
  1093. else
  1094. comprobarError 1 304
  1095. fi
  1096. fi
  1097. # Activamos repositorio remi-php72
  1098. result=$(yum-config-manager --enable remi-php72 2>&1)
  1099. comprobarError $? 303 $result
  1100. # Instalamos PHP-7.2
  1101. if [ $apacheOn = true ];then
  1102. result=$(yum -y install php php-mysql php-intl php-mbstring php-mcrypt php-xml php-pecl-apcu php-gd php-pear-Net-Curl php-pecl-zip php-soap php-xmlrpc 2>&1)
  1103. comprobarError $? 302 $result
  1104. elif [ $nginxOn = true ];then
  1105. phpFPMName="php-fpm"
  1106. result=$(yum -y install php php-fpm php-mysql php-intl php-mbstring php-mcrypt php-xml php-pecl-apcu php-gd php-pear-Net-Curl php-pecl-zip php-soap php-xmlrpc 2>&1)
  1107. comprobarError $? 302 $result
  1108. deshabilitarServicio $phpFPMName
  1109. else
  1110. comprobarError 1 301
  1111. fi
  1112. else
  1113. comprobarError 1 300
  1114. fi
  1115. }
  1116. configurarPHP() {
  1117. # Configura PHP para segurizarlo y establecer máximo de subida.
  1118. if [ $debianOS = true ];then
  1119. phpConfFile="./etc/php/php.ini.debian"
  1120. phpDest="/etc/php/7.2/cli/php.ini"
  1121. elif [ $rhelOS = true ];then
  1122. phpConfFile="./etc/php/php.ini.rhel"
  1123. phpDest="/etc/php.ini"
  1124. fi
  1125. if [ ! -f $phpConfFile ];then
  1126. comprobarError 1 4 "$phpConfFile"
  1127. fi
  1128. # Copiamos configuración
  1129. cp -f $phpConfFile $phpDest 2>/dev/null
  1130. comprobarError $? 305
  1131. # Configuramos cgi.fix_pathinfo
  1132. sed -i '/cgi.fix_pathinfo=/c\cgi.fix_pathinfo=0' $phpDest
  1133. comprobarError $? 305
  1134. # Configuramos post_max_size
  1135. sed -i '/post_max_size =/c\post_max_size = '$maxUpload $phpDest
  1136. comprobarError $? 305
  1137. # Configuramos upload_max_filesize
  1138. sed -i '/upload_max_filesize =/c\upload_max_filesize = '$maxUpload $phpDest
  1139. comprobarError $? 305
  1140. # Configurar php-fpm (sólo en RHEL con Nginx)
  1141. if [ $rhelOS = true ] && [ $nginxOn = true ];then
  1142. # Configurar Socket UNIX
  1143. phpConfFile="./etc/php/php-fpm.d/www.conf"
  1144. phpDest="/etc/php-fpm.d/www.conf"
  1145. if [ ! -f $phpConfFile ];then
  1146. comprobarError $? 4 "$phpConfFile"
  1147. fi
  1148. cp -f $phpConfFile $phpDest 2>/dev/null
  1149. comprobarError $? 305
  1150. # Configurar Permisos /var/lib/php
  1151. chown -R $webServerUser:$webServerGroup /var/lib/php/
  1152. comprobarError $? 305
  1153. fi
  1154. unset phpConfFile phpDest
  1155. }
  1156. establecerMaxUpload() {
  1157. # Pantalla para establecer el máximo de subida al servidor (vía PHP)
  1158. control=false
  1159. error=""
  1160. while [ $control = false ];do
  1161. maxUpload2=$(whiptail --title "PHP MAX UPLOAD" --inputbox "$error""Introduzca el tamaño máximo permitido de los ficheros subidos al servidor:\n(<K:Kilobyte> <M:Megabyte> <G:Gigabyte>)" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) $maxUpload --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  1162. comprobarError $? 1
  1163. if [ -z "$maxUpload2" ];then
  1164. error="ERROR: NO PUEDES DEJAR ESTE PARÁMETRO VACIO.\n"
  1165. else
  1166. control=true
  1167. fi
  1168. done
  1169. maxUpload=$maxUpload2
  1170. unset control maxUpload2
  1171. }
  1172. instalarPHPInfo() {
  1173. # Instalar fichero info.php y su VirtualHost
  1174. if [ ! -f /etc/$webServerName/sites-enabled/phpinfo.conf ];then
  1175. infoFile="./var/www/info.php"
  1176. if [ ! -f $infoFile ];then
  1177. comprobarError 1 4 "$infoFile"
  1178. fi
  1179. mkdir /var/www/localhost 2>/dev/null
  1180. comprobarError $? 106
  1181. cp -f $infoFile /var/www/localhost/ 2>/dev/null
  1182. comprobarError $? 106
  1183. chown -R $webServerUser:$webServerGroup /var/www/localhost 2>/dev/null
  1184. comprobarError $? 106
  1185. unset infoFile
  1186. # Instalar VirtualHost
  1187. if [ $apacheOn = true ] && [ $sslOn = false ];then
  1188. virtualHost="./etc/apache2/sites-available/phpinfo.conf"
  1189. elif [ $nginxOn = true ] && [ $sslOn = false ];then
  1190. virtualHost="./etc/nginx/sites-available/phpinfo.conf"
  1191. elif [ $apacheOn = true ] && [ $sslOn = true ];then
  1192. virtualHost="./etc/apache2/sites-available/phpinfo-ssl.conf"
  1193. elif [ $nginxOn = true ] && [ $sslOn = true ];then
  1194. virtualHost="./etc/nginx/sites-available/phpinfo-ssl.conf"
  1195. else
  1196. comprobarError 1 106
  1197. fi
  1198. instalarVirtualHost "/var/www/localhost" $virtualHost "localhost"
  1199. unset virtualHost
  1200. return 0
  1201. else
  1202. return 1
  1203. fi
  1204. }
  1205. habilitarServicio() {
  1206. # Arrancamos y habilitamos el servicio (con SystemD, Upstart o SystemV)
  1207. # Intentamos con systemctl (SystemD)
  1208. #echo -en "Habilitando Servicio '$1'" | tee -a $logFile
  1209. if [ $# -le 0 ];then
  1210. comprobarError 1 900
  1211. fi
  1212. which systemctl > /dev/null 2>&1
  1213. if [ $? -eq 0 ]; then
  1214. #echo -en " (SystemD)..." | tee -a $logFile
  1215. systemctl start $1 > /dev/null 2>&1
  1216. comprobarError $? 901 $1
  1217. systemctl enable $1 > /dev/null 2>&1
  1218. comprobarError $? 902 $1
  1219. else
  1220. # Intentamos con service (Upstart)
  1221. which service > /dev/null 2>&1
  1222. if [ $? -eq 0 ]; then
  1223. #echo -en " (Upstart)..." | tee -a $logFile
  1224. service $1 start > /dev/null 2>&1
  1225. comprobarError $? 901 $1
  1226. else
  1227. # Intentamos con init.d (SystemV)
  1228. #echo -en " (SystemV)..." | tee -a $logFile
  1229. /etc/init.d/$1 start > /dev/null 2>&1
  1230. comprobarError $? 901 $1
  1231. fi
  1232. # Intentamos habilitar en el arranque (Upstart)
  1233. which update-rc.d > /dev/null 2>&1
  1234. if [ $? -eq 0 ];then
  1235. update-rc.d $1 enable
  1236. comprobarError $? 902 $1
  1237. else
  1238. # Intentamos habilitar en el arranque (SystemV)
  1239. which chkconfig > /dev/null 2>&1
  1240. if [ $? -eq 0 ];then
  1241. chkconfig $1 on
  1242. comprobarError $? 902 $1
  1243. else
  1244. # ¿Qué mas opciones nos quedan?
  1245. comprobarError 1 902 $1
  1246. fi
  1247. fi
  1248. fi
  1249. # Mejora: comprobar si el servicio está parado
  1250. #echo -en " OK.\n" | tee -a $logFile
  1251. }
  1252. deshabilitarServicio() {
  1253. # Paramos y deshabilitamos el servicio (con SystemD, Upstart o SystemV)
  1254. # Intentamos con systemctl (SystemD)
  1255. #echo -en "Deshabilitando Servicio '$1'" | tee -a $logFile
  1256. if [ $# -le 0 ];then
  1257. comprobarError 1 903
  1258. fi
  1259. which systemctl > /dev/null 2>&1
  1260. if [ $? -eq 0 ]; then
  1261. #echo -en " (SystemD)..." | tee -a $logFile
  1262. systemctl stop $1 > /dev/null 2>&1
  1263. comprobarError $? 904 $1
  1264. systemctl disable $1 > /dev/null 2>&1
  1265. comprobarError $? 905 $1
  1266. else
  1267. # Intentamos con service (Upstart)
  1268. which service > /dev/null 2>&1
  1269. if [ $? -eq 0 ]; then
  1270. #echo -en " (Upstart)..." | tee -a $logFile
  1271. service $1 stop > /dev/null 2>&1
  1272. comprobarError $? 904 $1
  1273. else
  1274. # Intentamos con init.d (SystemV)
  1275. #echo -en " (SystemV)..." | tee -a $logFile
  1276. /etc/init.d/$1 stop > /dev/null 2>&1
  1277. comprobarError $? 904 $1
  1278. fi
  1279. # Intentamos habilitar en el arranque (Upstart)
  1280. which update-rc.d > /dev/null 2>&1
  1281. if [ $? -eq 0 ];then
  1282. update-rc.d $1 disable
  1283. comprobarError $? 905 $1
  1284. else
  1285. # Intentamos habilitar en el arranque (SystemV)
  1286. which chkconfig > /dev/null 2>&1
  1287. if [ $? -eq 0 ];then
  1288. chkconfig $1 off
  1289. comprobarError $? 905 $1
  1290. else
  1291. # ¿Qué mas opciones nos quedan?
  1292. comprobarError 1 905 $1
  1293. fi
  1294. fi
  1295. fi
  1296. # Mejora: comprobar si el servicio está funcionando
  1297. #echo -en " OK.\n" | tee -a $logFile
  1298. }
  1299. recargarServicio() {
  1300. # Recargamos el servicio (con SystemD, Upstart o SystemV)
  1301. # Intentamos con systemctl (SystemD)
  1302. #echo -en "Recargando Servicio '$1'" | tee -a $logFile
  1303. if [ $# -le 0 ];then
  1304. comprobarError 1 912
  1305. fi
  1306. which systemctl > /dev/null 2>&1
  1307. if [ $? -eq 0 ]; then
  1308. #echo -en " (SystemD)..." | tee -a $logFile
  1309. systemctl reload $1 > /dev/null 2>&1
  1310. comprobarError $? 913 $1
  1311. else
  1312. # Intentamos con service (Upstart)
  1313. which service > /dev/null 2>&1
  1314. if [ $? -eq 0 ]; then
  1315. #echo -en " (Upstart)..." | tee -a $logFile
  1316. service $1 reload > /dev/null 2>&1
  1317. comprobarError $? 913 $1
  1318. else
  1319. # Intentamos con init.d (SystemV)
  1320. #echo -en " (SystemV)..." | tee -a $logFile
  1321. /etc/init.d/$1 reload > /dev/null 2>&1
  1322. comprobarError $? 913 $1
  1323. fi
  1324. fi
  1325. # Mejora: comprobar si el servicio está funcionando
  1326. #echo -en " OK.\n" | tee -a $logFile
  1327. }
  1328. configurarCortafuegos() {
  1329. # Configuramos cortafuegos (añadir reglas y encender)
  1330. # Comprobamos si estamos usando SSH
  1331. esSSH $PPID
  1332. if [ $debianOS = true ];then
  1333. ufw allow 80/tcp >> $logFile 2>&1
  1334. comprobarError $? 906 "80/tcp"
  1335. if [ $sshControl = true ];then
  1336. ufw allow 22/tcp >> $logFile 2>&1
  1337. comprobarError $? 906 "22/tcp"
  1338. fi
  1339. if [ $sslOn = true ];then
  1340. ufw allow 443/tcp >> $logFile 2>&1
  1341. comprobarError $? 906 "443/tcp"
  1342. fi
  1343. ufw --force enable >> $logFile 2>&1
  1344. comprobarError $? 907
  1345. elif [ $rhelOS = true ];then
  1346. firewall-cmd --add-port=80/tcp >> $logFile 2>&1
  1347. comprobarError $? 906 "80/tcp"
  1348. if [ $sshControl = true ];then
  1349. firewall-cmd --add-port=22/tcp >> $logFile 2>&1
  1350. comprobarError $? 906 "22/tcp"
  1351. fi
  1352. if [ $sslOn = true ];then
  1353. firewall-cmd --add-port=443/tcp >> $logFile 2>&1
  1354. comprobarError $? 906 "443/tcp"
  1355. fi
  1356. firewall-cmd --runtime-to-permanent >> $logFile 2>&1
  1357. comprobarError $? 907
  1358. habilitarServicio firewalld >> $logFile 2>&1
  1359. comprobarError $? 907
  1360. fi
  1361. unset sshControl
  1362. }
  1363. esSSH() {
  1364. # Comprobamos si nuestro terminal usa SSH
  1365. p=${1:-$PPID}
  1366. #read pid name x ppid y < <( cat /proc/$p/stat )
  1367. read pid name ppid < <( ps -o pid= -o comm= -o ppid= -p $p)
  1368. [[ "$name" =~ sshd ]] && { sshControl=true; return 0; }
  1369. [ "$ppid" -le 1 ] && { sshControl=false; return 1; }
  1370. esSSH $ppid
  1371. }
  1372. descargarMediaWiki() {
  1373. # Descargar la versión 1.31.0 de MediaWiki
  1374. if [ ! -d ./var ];then
  1375. comprobarError 1 5 "./var"
  1376. fi
  1377. curl "https://releases.wikimedia.org/mediawiki/1.31/mediawiki-1.31.0.tar.gz" 2>/dev/null | tar -xz -C "./var/"
  1378. comprobarError $? 501
  1379. }
  1380. configurarMediaWiki() {
  1381. # Configuramos MediaWiki
  1382. if [ ! -f /var/www/$dominioMediaWiki/LocalSettings.php ];then
  1383. # Copiamos archivos
  1384. cp -fR ./var/mediawiki-1.31.0/ /var/www/$dominioMediaWiki
  1385. comprobarError $? 502
  1386. # Configuramos LocalSettings.php (y crea la base de datos por nosotros)
  1387. nombreDBMW=$(echo $dominioMediaWiki | sed -e 's/\./_/g')
  1388. userDBMW=$(echo $dominioMediaWiki | sed -e 's/\./_/g')
  1389. php /var/www/$dominioMediaWiki/maintenance/install.php --dbname=$nombreDBMW --dbserver="localhost" --installdbuser=root --installdbpass=$sqlPasswd --dbuser=$userDBMW --dbpass=$sqlPasswd --scriptpath="" --lang=es --pass=$passwdMediaWiki --with-extensions "$nombreMediaWiki" "admin" >> $logFile 2>&1
  1390. comprobarError $? 502
  1391. # Configuraciones adicionales
  1392. sed -i '/$wgLanguageCode =/c\$wgLanguageCode = "es";' /var/www/$dominioMediaWiki/LocalSettings.php
  1393. comprobarError $? 502
  1394. sed -i '/$wgEnableEmail =/c\$wgEnableEmail = false;' /var/www/$dominioMediaWiki/LocalSettings.php
  1395. comprobarError $? 502
  1396. sed -i '/$wgEnableUploads =/c\$wgEnableUploads = true;' /var/www/$dominioMediaWiki/LocalSettings.php
  1397. comprobarError $? 502
  1398. echo -en "\$wgArticlePath = \"/wiki/\$1\";\n" >> /var/www/$dominioMediaWiki/LocalSettings.php
  1399. echo -en "\$wgUsePathInfo = true;\n" >> /var/www/$dominioMediaWiki/LocalSettings.php
  1400. echo -en "\$wgGroupPermissions['*']['createaccount'] = true;\n" >> /var/www/$dominioMediaWiki/LocalSettings.php
  1401. echo -en "\$wgGroupPermissions['*']['edit'] = false;\n" >> /var/www/$dominioMediaWiki/LocalSettings.php
  1402. echo -en "\$wgGroupPermissions['*']['read'] = true;\n" >> /var/www/$dominioMediaWiki/LocalSettings.php
  1403. # Actualizamos permisos
  1404. chown -R $webServerUser:$webServerGroup /var/www/$dominioMediaWiki
  1405. comprobarError $? 502
  1406. # Configuramos VirtualHost
  1407. if [ $apacheOn = true ] && [ $sslOn = false ];then
  1408. virtualHost="./etc/apache2/sites-available/mediawiki.conf"
  1409. elif [ $nginxOn = true ] && [ $sslOn = false ];then
  1410. virtualHost="./etc/nginx/sites-available/mediawiki.conf"
  1411. elif [ $apacheOn = true ] && [ $sslOn = true ];then
  1412. virtualHost="./etc/apache2/sites-available/mediawiki-ssl.conf"
  1413. elif [ $nginxOn = true ] && [ $sslOn = true ];then
  1414. virtualHost="./etc/nginx/sites-available/mediawiki-ssl.conf"
  1415. else
  1416. comprobarError 1 502
  1417. fi
  1418. if [ ! -f $virtualHost ];then
  1419. comprobarError $? 502
  1420. fi
  1421. instalarVirtualHost "/var/www/$dominioMediaWiki" $virtualHost $dominioMediaWiki $aliasMediaWiki
  1422. unset virtualHost
  1423. else
  1424. comprobarError 1 503 $dominioMediaWiki
  1425. fi
  1426. }
  1427. descargarMoodle() {
  1428. # Descargar la versión 1.31.0 de MediaWiki
  1429. if [ ! -d ./var ];then
  1430. comprobarError 1 5 "./var"
  1431. fi
  1432. #echo -en "Descargando Moodle-3.5-1..." | tee -a $logFile
  1433. #curl -o "./var/moodle-3.5.1.tgz" "https://download.moodle.org/download.php/direct/stable35/moodle-latest-35.tgz" >> $logFile 2>&1
  1434. curl "https://download.moodle.org/download.php/direct/stable35/moodle-latest-35.tgz" 2>/dev/null | tar -xz -C "./var/"
  1435. comprobarError $? 501
  1436. #echo -en " OK.\n" | tee -a $logFile
  1437. }
  1438. configurarMoodle() {
  1439. # Configurar Moodle
  1440. if [ ! -f /var/www/$dominioMoodle/config.php ];then
  1441. # Copiamos archivos
  1442. cp -Rf ./var/moodle/ /var/www/$dominioMoodle
  1443. comprobarError $? 602
  1444. # Crear carperta de datos (no online)
  1445. if [ ! -d /var/www/moodledata ];then
  1446. mkdir /var/www/moodledata 2>/dev/null
  1447. comprobarError $? 602
  1448. fi
  1449. #Actualizamos permisos
  1450. perm=$(stat -c %a /var/www/moodledata)
  1451. if [ $perm -ne 777 ];then
  1452. chmod -R 777 /var/www/moodledata 2>/dev/null
  1453. comprobarError $? 602
  1454. fi
  1455. perm=$(stat -c %U /var/www/moodledata)
  1456. if [ $perm != "$webServerUser" ];then
  1457. chown -R $webServerUser:$webServerGroup /var/www/moodledata 2>/dev/null
  1458. comprobarError $? 602
  1459. fi
  1460. unset perm
  1461. # Creamos Base de Datos
  1462. nombreDBMo=$(echo $dominioMoodle | sed -e 's/\./_/g')
  1463. userDBMo=$(echo $dominioMoodle | sed -e 's/\./_/g')
  1464. crearDBMoodle
  1465. # Configurar SE-Linux (RHEL)
  1466. if [ $rhelOS = true ];then
  1467. configurarSELinux
  1468. fi
  1469. # Configuramos e instalamos Moodle
  1470. if [ $sslOn = true ];then
  1471. wwwroot="https://$dominioMoodle"
  1472. else
  1473. wwwroot="http://$dominioMoodle"
  1474. fi
  1475. if [ $mySQLOn = true ];then
  1476. dbtype="mysqli"
  1477. elif [ $mariaDBOn = true ];then
  1478. dbtype="mariadb"
  1479. else
  1480. comprobarError 1 602
  1481. fi
  1482. php /var/www/$dominioMoodle/admin/cli/install.php --lang=es --wwwroot="$wwwroot" --dataroot="/var/www/moodledata" --dbtype="$dbtype" --dbname="$nombreDBMo" --dbuser="$userDBMo" --dbpass="$sqlPasswd" --fullname="$nombreMoodle" --shortname="$nombreCortoMoodle" --adminuser=admin --adminpass="$passwdMoodle" --adminemail="admin@$dominioMoodle" --agree-license --non-interactive >>$logFile 2>&1
  1483. comprobarError $? 602
  1484. # Actualizamos permisos
  1485. chown -R $webServerUser:$webServerGroup /var/www/$dominioMoodle /var/www/moodledata
  1486. # Configuramos VirtualHost
  1487. if [ $apacheOn = true ] && [ $sslOn = false ];then
  1488. virtualHost="./etc/apache2/sites-available/moodle.conf"
  1489. elif [ $nginxOn = true ] && [ $sslOn = false ];then
  1490. virtualHost="./etc/nginx/sites-available/moodle.conf"
  1491. elif [ $apacheOn = true ] && [ $sslOn = true ];then
  1492. virtualHost="./etc/apache2/sites-available/moodle-ssl.conf"
  1493. elif [ $nginxOn = true ] && [ $sslOn = true ];then
  1494. virtualHost="./etc/nginx/sites-available/moodle-ssl.conf"
  1495. else
  1496. comprobarError 1 602
  1497. fi
  1498. instalarVirtualHost "/var/www/$dominioMoodle" $virtualHost $dominioMoodle
  1499. unset virtualHost wwwroot dbtype
  1500. else
  1501. comprobarError 1 603 $dominioMoodle
  1502. fi
  1503. }
  1504. crearDBMoodle() {
  1505. # Crear base de datos para Moodle
  1506. dbDir="./etc/db"
  1507. if [ ! -d $dbDir ];then
  1508. mkdir $dbDir 2>/dev/null
  1509. comprobarError $? 503
  1510. fi
  1511. dbFile=$dbDir"/moodle.sql"
  1512. echo -en "CREATE DATABASE IF NOT EXISTS $nombreDBMo DEFAULT CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;\n" > $dbFile
  1513. echo -en "GRANT ALL PRIVILEGES ON $nombreDBMo.* TO '$userDBMo'@'localhost' IDENTIFIED BY '$sqlPasswd';\n" >> $dbFile
  1514. mysql -u root --password=$sqlPasswd < $dbFile
  1515. control=$?
  1516. rm -f $dbFile 2>/dev/null
  1517. comprobarError $? 503
  1518. comprobarError $control 503
  1519. unset control dbFile dbDir
  1520. }
  1521. configurarSELinux() {
  1522. # Configurar SELinux (Sólo para RHEL)
  1523. which semanage >/dev/null 2>&1
  1524. if [ $? -ne 0 ];then
  1525. result=$(yum -y install policycoreutils-python 2>&1)
  1526. comprobarError $? 605 $result
  1527. fi
  1528. semanage fcontext -a -t httpd_sys_rw_content_t "/var/www/moodledata(/.*)?" > /dev/null 2>&1
  1529. comprobarError $? 604
  1530. restorecon -R /var/www/ > /dev/null 2>&1
  1531. comprobarError $? 604
  1532. }
  1533. # Comprobación del sistema e inicialización
  1534. inicializarVariables
  1535. comprobarRoot
  1536. OSInfo
  1537. comprobarDependencias
  1538. # Bienvenida
  1539. mostrarBienvenida
  1540. # Selección de componentes (express vs avanzada)
  1541. mostrarExpress
  1542. # Instalación Servidor Web
  1543. if [ $apacheOn = true ]; then
  1544. echo -en "Instalando Servidor Web Apache..." | tee -a $logFile
  1545. instalarApache
  1546. echo -en " OK.\n" | tee -a $logFile
  1547. elif [ $nginxOn = true ]; then
  1548. echo -en "Instalando Servidor Web Nginx..." | tee -a $logFile
  1549. instalarNginx
  1550. echo -en " OK.\n" | tee -a $logFile
  1551. fi
  1552. # Instalación Base de Datos
  1553. if [ $mySQLOn = true ]; then
  1554. echo -en "Instalando Base de Datos MySQL..." | tee -a $logFile
  1555. instalarMySQL
  1556. echo -en " OK.\n" | tee -a $logFile
  1557. elif [ $mariaDBOn = true ]; then
  1558. echo -en "Instalando Base de Datos MariaDB..." | tee -a $logFile
  1559. instalarMariaDB
  1560. echo -en " OK.\n" | tee -a $logFile
  1561. fi
  1562. # Instalación PHP-7.2
  1563. if [ $phpOn = true ]; then
  1564. echo -en "Instalando PHP-7..." | tee -a $logFile
  1565. instalarPHP
  1566. echo -en " OK.\n" | tee -a $logFile
  1567. fi
  1568. # Instalación SSL/TLS
  1569. if [ $sslOn = true ];then
  1570. echo -en "Instalando SSL/TLS..." | tee -a $logfile
  1571. sleep 2
  1572. echo -en " OK.\n" | tee -a $logFile
  1573. fi
  1574. # Configuración Web Server
  1575. if [ $apacheOn = true ];then
  1576. echo -en "Configurando Servidor Web Apache..." | tee -a $logFile
  1577. configurarApache
  1578. echo -en " OK.\n" | tee -a $logFile
  1579. elif [ $nginxOn = true ]; then
  1580. echo -en "Configurando Servidor Web Nginx..." | tee -a $logFile
  1581. configurarNginx
  1582. echo -en " OK.\n" | tee -a $logFile
  1583. fi
  1584. # Configuración Database (Arrancar Base de Datos, establecer contraseña y configuración segura)
  1585. if [ $mySQLOn = true ] || [ $mariaDBOn = true ];then
  1586. echo -en "Configurando Base de Datos..." | tee -a $logFile
  1587. configurarSQL
  1588. echo -en " OK.\n" | tee -a $logFile
  1589. habilitarServicio "$sqlServerName"
  1590. echo -en "Estableciendo contraseña de la Base de Datos..." | tee -a $logFile
  1591. establecerSQLPasswd
  1592. echo -en " OK.\n" | tee -a $logFile
  1593. fi
  1594. # Configuración PHP (cgi.fix_pathinfo=0 y Configurar máximo de subida de archivos)
  1595. if [ $phpOn = true ];then
  1596. echo -en "Configurando PHP-7..." | tee -a $logFile
  1597. configurarPHP
  1598. echo -en " OK.\n" | tee -a $logFile
  1599. fi
  1600. # Configuración SSL/TLS
  1601. # Generar certificados
  1602. # Configurar certificados
  1603. if [ $sslOn = true ];then
  1604. echo -en "Configurando SSL/TLS..." | tee -a $logFile
  1605. sleep 2
  1606. echo -en " OK.\n" | tee -a $logFile
  1607. fi
  1608. # Arrancar y habilitar todos los servicios (SystemD, Service o SystemV)
  1609. echo -en "Habilitando todos los servicios..." | tee -a $logFile
  1610. if [ $apacheOn = true ];then
  1611. habilitarServicio $webServerName
  1612. elif [ $nginxOn = true ];then
  1613. habilitarServicio $webServerName
  1614. if [ $phpOn = true ];then
  1615. habilitarServicio $phpFPMName
  1616. fi
  1617. fi
  1618. echo -en " OK.\n" | tee -a $logFile
  1619. # MediaWiki
  1620. if [ $mediaWikiOn = true ]; then
  1621. # Descargar MediaWiki
  1622. echo -en "Descargando MediaWiki-1.31.0..." | tee -a $logFile
  1623. descargarMediaWiki
  1624. echo -en " OK.\n" | tee -a $logFile
  1625. # Configurar MediWiki
  1626. echo -en "Configurando MediaWiki..." | tee -a $logFile
  1627. configurarMediaWiki
  1628. echo -en " OK.\n" | tee -a $logFile
  1629. fi
  1630. # Moodle
  1631. if [ $moodleOn = true ]; then
  1632. # Descargar Moodle
  1633. echo -en "Descargando Moodle-3.5.1..." | tee -a $logFile
  1634. descargarMoodle
  1635. echo -en " OK.\n" | tee -a $logFile
  1636. # Configuración Moodle
  1637. echo -en "Configurando Moodle (puede llevar un tiempo largo)..." | tee -a $logFile
  1638. configurarMoodle
  1639. echo -en " OK.\n" | tee -a $logFile
  1640. fi
  1641. # Configurar Virtual Hosts
  1642. # Instalar info.php
  1643. if [ $infoPHPOn = true ];then
  1644. echo -en "Configurando 'info.php'..." | tee -a $logFile
  1645. instalarPHPInfo
  1646. if [ $? -eq 0 ];then
  1647. echo -en " OK.\n" | tee -a $logFile
  1648. else
  1649. echo -en " Ya se encuentra configurado.\n" | tee -a $logFile
  1650. fi
  1651. fi
  1652. # Añadir reglas del cortafuegos
  1653. echo -en "Configurando Cortafuegos..." | tee -a $logFile
  1654. configurarCortafuegos
  1655. echo -en " OK.\n" | tee -a $logFile
  1656. # Configurar Backup
  1657. if [ $backupOn = true ]; then
  1658. echo -en "Configurando Backup Automático..." | tee -a $logFile
  1659. sleep 2
  1660. echo -en " OK.\n" | tee -a $logFile
  1661. fi